import pytest

from ..templatetags.minified import get_minified_static_path


@pytest.mark.parametrize(
    'path, result',
    [
        ('css/app.css', 'css/app.min.css'),
        ('path/to/file.ext', 'path/to/file.ext'),
        ('path/to/file', 'path/to/file'),
    ],
)
def test_get_minified_static_path(path, result):
    assert get_minified_static_path(path) == result
