import django_tables2 as tables
from django_tables2.utils import A

from benevalibre.utils.html import fa_icon

from . import models


class BenevaloIndexTable(tables.Table):
    association = tables.LinkColumn(
        'association:update', args=(A('association.id'),)
    )
    project = tables.LinkColumn(
        'association:project:update',
        args=(A('association.id'), A('project.id')),
        attrs={'a': {'class': 'project-link'}},
    )
    category = tables.LinkColumn(
        'association:category:update',
        args=(A('association.id'), A('category.id')),
        attrs={'a': {'class': 'category-link'}},
    )
    level = tables.LinkColumn(
        'association:level:update',
        args=(A('association.id'), A('level.id')),
        attrs={'a': {'class': 'level-link'}},
    )
    title = tables.LinkColumn('benevalo:update', args=(A('pk'),))
    update = tables.LinkColumn(
        'benevalo:update',
        verbose_name="Éditer",
        text=fa_icon('edit'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'update-link'}},
    )
    delete = tables.LinkColumn(
        'benevalo:delete',
        verbose_name="Effacer",
        text=fa_icon('trash-o'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'delete-link text-danger'}},
    )

    # FIXME: lier les utilisateurs
    # FIXME: liste des colonnes par préférence utilisateur
    class Meta:
        model = models.Benevalo
        fields = (
            'user',
            'execution_date',
            'association',
            'project',
            'category',
            'level',
            'title',
            'update',
            'delete',
        )
