from django.urls import reverse, reverse_lazy

from cruditor import views

from benevalibre.utils.html import fa_icon
from benevalibre.utils.views import StaffCruditorMixin

from . import forms, models, tables


class BenevaloViewMixin(StaffCruditorMixin):
    model = models.Benevalo
    success_url = reverse_lazy('benevalo:index')


class Index(BenevaloViewMixin, views.CruditorListView):
    title = 'Liste des bénévolats'
    table_class = tables.BenevaloIndexTable

    def get_titlebutton_condition(self):
        return True

    def get_titlebutton_url(self):
        return reverse('benevalo:create')

    def get_titlebutton_label(self):
        return fa_icon('plus-circle', "Ajouter un bénévolat")


class Create(BenevaloViewMixin, views.CruditorAddView):
    form_class = forms.CreateForm


class Update(BenevaloViewMixin, views.CruditorChangeView):
    form_class = forms.UpdateForm

    def get_delete_url(self):
        return reverse('benevalo:delete', args=(self.object.pk,))


class Delete(BenevaloViewMixin, views.CruditorDeleteView):
    pass
