import django_tables2 as tables
from django_tables2.utils import A

from benevalibre.utils.html import fa_icon

from . import models


class DefaultRoleIndexTable(tables.Table):
    update = tables.LinkColumn(
        'instance:role:update',
        verbose_name="éditer",
        text=fa_icon('edit'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'update-link'}},
    )
    delete = tables.LinkColumn(
        'instance:role:delete',
        verbose_name="effacer",
        text=fa_icon('trash-o'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'delete-link text-danger'}},
    )
    name = tables.LinkColumn('instance:role:update', args=(A('pk'),))

    class Meta:
        model = models.DefaultRole
        fields = ('name', 'update', 'delete')


class DefaultLevelIndexTable(tables.Table):
    update = tables.LinkColumn(
        'instance:level:update',
        verbose_name="éditer",
        text=fa_icon('edit'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'update-link'}},
    )
    delete = tables.LinkColumn(
        'instance:level:delete',
        verbose_name="effacer",
        text=fa_icon('trash-o'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'delete-link text-danger'}},
    )
    name = tables.LinkColumn('instance:level:update', args=(A('pk'),))

    class Meta:
        model = models.DefaultLevel
        fields = ('name', 'update', 'delete')


class DefaultCategoryIndexTable(tables.Table):
    update = tables.LinkColumn(
        'instance:category:update',
        verbose_name="éditer",
        text=fa_icon('edit'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'update-link'}},
    )
    delete = tables.LinkColumn(
        'instance:category:delete',
        verbose_name="effacer",
        text=fa_icon('trash-o'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'delete-link text-danger'}},
    )
    name = tables.LinkColumn('instance:category:update', args=(A('pk'),))

    class Meta:
        model = models.DefaultCategory
        fields = ('name', 'instance_category', 'update', 'delete')


class InstanceCategoryIndexTable(tables.Table):
    update = tables.LinkColumn(
        'instance:instance_category:update',
        verbose_name="éditer",
        text=fa_icon('edit'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'update-link'}},
    )
    delete = tables.LinkColumn(
        'instance:instance_category:delete',
        verbose_name="effacer",
        text=fa_icon('trash-o'),
        args=(A('pk'),),
        orderable=False,
        attrs={'a': {'class': 'delete-link text-danger'}},
    )
    name = tables.LinkColumn(
        'instance:instance_category:update', args=(A('pk'),)
    )

    class Meta:
        model = models.InstanceCategory
        fields = ('name', 'update', 'delete')
