from collections import namedtuple

from django.urls import include, path

ViewDat = namedtuple(
    'ViewDat', ['urlsuffix', 'viewsuffix', 'namesuffix', 'activated']
)


def crudipath(
    views,
    urlprefix,
    viewprefix,
    namespace,
    index=True,
    detail=False,
    create=True,
):
    urlpattern = [
        path(
            v.urlsuffix,
            getattr(views, viewprefix + v.viewsuffix).as_view(),
            name=v.namesuffix,
        )
        for v in [
            ViewDat('', 'Index', 'index', index),
            ViewDat('create/', 'Create', 'create', create),
            ViewDat('<int:pk>/', 'Detail', 'detail', detail),
            ViewDat('<int:pk>/update/', 'Update', 'update', True),
            ViewDat('<int:pk>/delete/', 'Delete', 'delete', True),
        ]
        if v.activated
    ]
    if namespace and urlprefix:
        return [path(urlprefix, include((urlpattern, namespace)))]
    elif not namespace and not urlprefix:
        return urlpattern
    else:
        raise NotImplementedError(
            "Vous devriez définir un namespace si vous "
            "utilisez un préfixe d'url."
        )
